/******************** RDM8800 *************************
This is the first vesion source code of RDM8800.It' basic 
on the source code that written by Stan Lee(Lizq@iteadstudio.com).
It implements the use of a microcontroller to read the 13.56MHz RFID Tag
and output the card ID .

And is send the ID number by HEX. 


eg.

 ID num			output(10 bits)
46553491	0x30 0x30 0x34 0x36 0x35 0x35 0x33 0x34 0x39 0x31 (0x0D 0x0A)



                                  iteadstudio.com  12/26/2013
************************************************************/

#include <PN532.h>
#include <SPI.h>

#define Direct_ID 0
#define Parity_ID 1
const int LED = 3;

#define PN532_CS 10
PN532 nfc(PN532_CS);
//#define  NFC_DEMO_DEBUG 1
unsigned int frame_format;

unsigned char parity_buffer[5];
unsigned char id_buffer[10];

void setup(void) {
  Serial.begin(9600);  
  nfc.begin();
  nfc.SAMConfig();

  pinMode(LED,OUTPUT);
  digitalWrite(LED,LOW);

    
}


void loop(void) {
  uint32_t id;
  // look for MiFare type cards
  id = nfc.readPassiveTargetID(PN532_MIFARE_ISO14443A);
  


		if (id != 0) 
		{
			digitalWrite(LED,HIGH);
			delay(10);
			digitalWrite(LED,LOW);
			hex_to_dec(id);
			for(unsigned char i=0;i<10;i++)
			{
				Serial.write(id_buffer[i]);
			}
			Serial.println();

		}

	
}



void hex_to_dec(uint32_t value)
{
	id_buffer[0] = 0x30 + value / 1000000000;
	id_buffer[1] = 0x30 + value % 1000000000 / 100000000;
	id_buffer[2] = 0x30 + value % 100000000 / 10000000;
	id_buffer[3] = 0x30 + value % 10000000 / 1000000;
	id_buffer[4] = 0x30 + value % 1000000 / 100000;
	id_buffer[5] = 0x30 + value % 100000 / 10000;
	id_buffer[6] = 0x30 + value % 10000 / 1000;
	id_buffer[7] = 0x30 + value % 1000 / 100;
	id_buffer[8] = 0x30 + value % 100 / 10;
	id_buffer[9] = 0x30 + value % 10;
}

